/*  Physical constants for CALC */
/*               -cmn 8/20/93   */
/*     revised to IAU1976 a/o VLBA values */
/*         rmc  27jul99          */
/********************************/

#define v_light   299792.458e3 /* velocity of light  m/s */
#define gauss   0.01720209895  /* sqrt(1/(2*pi))  */
#define accelgrv  9.78031846  /* gravitational acceleration at equator */
#define gm_sun   1.32712438e20 /* GM for sun */
#define gm_moon   4.90279750e12 /* GM for moon */
#define tsec_au   499.004782    /*time seconds per a.u. */
#define earth_rad 6378137.0 /* equatorial radius of the earth */
#define ems_mms   81.3006808   /* earth-moon mass ratio */
#define univ_grav_con 6.672e-11 /* universal gravitational constant */
#define earth_flat 0.335281e-2 /* earth flattening constant */
#define prec_const 5029.0966 /* precession constant */
#define love_h    0.60967 /* earth tide constants */
#define love_l     0.085
#define etide_lag  0.
#define relative   1.  /* relativity constant - gamma(?) */
